diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc ns-3.34/src/sixlowpan/model/sixlowpan-net-device.cc
--- ns-3.33/src/sixlowpan/model/sixlowpan-net-device.cc	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/sixlowpan/model/sixlowpan-net-device.cc	2021-07-14 10:31:07.000000000 -0700
@@ -1759,7 +2111,11 @@
       break;
     case SixLowPanNhcExtension::EID_IPv6_H:
       actualHeaderType = Ipv6Header::IPV6_IPV6;
-      DecompressLowPanIphc (packet, src, dst);
+      if (DecompressLowPanIphc (packet, src, dst))
+        {
+          m_dropTrace (DROP_SATETFUL_DECOMPRESSION_PROBLEM, packet, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
+          return std::pair<uint8_t, bool> (0, true);
+        }
       break;
     default:
       NS_ABORT_MSG ("Trying to decode unknown Extension Header");
@@ -1767,7 +2123,7 @@
     }
 
   NS_LOG_DEBUG ( "Rebuilt packet: " << *packet << " Size " << packet->GetSize () );
-  return actualHeaderType;
+  return std::pair<uint8_t, bool> (actualHeaderType, false);
 }
 
 uint32_t
@@ -1898,6 +2254,7 @@
 void SixLowPanNetDevice::DoFragmentation (Ptr<Packet> packet,
                                           uint32_t origPacketSize,
                                           uint32_t origHdrSize,
+                                          uint32_t extraHdrSize,
                                           std::list<Ptr<Packet> >& listFragments)
 {
   NS_LOG_FUNCTION (this << *packet);
@@ -1920,8 +2277,9 @@
   uint32_t size;
   NS_ASSERT_MSG ( l2Mtu > frag1Hdr.GetSerializedSize (),
                   "6LoWPAN: can not fragment, 6LoWPAN headers are bigger than MTU");
-
-  size = l2Mtu - frag1Hdr.GetSerializedSize () - compressedHeaderSize;
+  
+  // All the headers are substracted to get remaining units for data
+  size = l2Mtu - frag1Hdr.GetSerializedSize () - compressedHeaderSize - extraHdrSize;
   size -= size % 8;
   size += compressedHeaderSize;
 
@@ -1942,7 +2300,7 @@
       fragNHdr.SetDatagramSize (origPacketSize);
       fragNHdr.SetDatagramOffset ((offset) >> 3);
 
-      size = l2Mtu - fragNHdr.GetSerializedSize ();
+      size = l2Mtu - fragNHdr.GetSerializedSize () - extraHdrSize;
       size -= size % 8;
 
       if ( (offsetData + size) > packetSize )
@@ -1951,16 +2309,18 @@
           moreFrag = false;
         }
 
-      NS_LOG_LOGIC ("Fragment creation - " << offset << ", " << offset );
-      Ptr<Packet> fragment = p->CreateFragment (offsetData, size);
-      NS_LOG_LOGIC ("Fragment created - " << offset << ", " << fragment->GetSize () );
-
-      offset += size;
-      offsetData += size;
+      if (size > 0)
+        {
+          NS_LOG_LOGIC ("Fragment creation - " << offset << ", " << offset );
+          Ptr<Packet> fragment = p->CreateFragment (offsetData, size);
+          NS_LOG_LOGIC ("Fragment created - " << offset << ", " << fragment->GetSize () );
 
-      fragment->AddHeader (fragNHdr);
-      listFragments.push_back (fragment);
+          offset += size;
+          offsetData += size;
 
+          fragment->AddHeader (fragNHdr);
+          listFragments.push_back (fragment);
+        }
     }
   while (moreFrag);
 
@@ -2013,7 +2373,11 @@
           DecompressLowPanHc1 (p, src, dst);
           break;
         case SixLowPanDispatch::LOWPAN_IPHC:
-          DecompressLowPanIphc (p, src, dst);
+          if (DecompressLowPanIphc (p, src, dst))
+            {
+              m_dropTrace (DROP_SATETFUL_DECOMPRESSION_PROBLEM, p, m_node->GetObject<SixLowPanNetDevice> (), GetIfIndex ());
+              return false;
+            }
           break;
         default:
           NS_FATAL_ERROR ("Unsupported 6LoWPAN encoding, exiting.");
@@ -2294,6 +2658,205 @@
   return;
 }
 
+void SixLowPanNetDevice::AddContext (uint8_t contextId, Ipv6Prefix contextPrefix, bool compressionAllowed, Time validLifetime)
+{
+  NS_LOG_FUNCTION (this << +contextId << Ipv6Address::GetOnes ().CombinePrefix (contextPrefix) << contextPrefix << compressionAllowed << validLifetime.As (Time::S));
+
+  if (contextId > 15)
+    {
+      NS_LOG_LOGIC ("Invalid context ID (" << +contextId << "), ignoring");
+      return;
+    }
+
+  if (validLifetime == Time(0))
+    {
+      NS_LOG_LOGIC ("Context (" << +contextId << "), removed (validity time is zero)");
+      m_contextTable.erase (contextId);
+      return;
+    }
+
+  m_contextTable[contextId].contextPrefix = contextPrefix;
+  m_contextTable[contextId].compressionAllowed = compressionAllowed;
+  m_contextTable[contextId].validLifetime = Simulator::Now () + validLifetime;
+
+  return;
+}
+
+bool SixLowPanNetDevice::GetContext (uint8_t contextId, Ipv6Prefix& contextPrefix, bool& compressionAllowed, Time& validLifetime)
+{
+  NS_LOG_FUNCTION (this << +contextId);
+
+  if (contextId > 15)
+    {
+      NS_LOG_LOGIC ("Invalid context ID (" << +contextId << "), ignoring");
+      return false;
+    }
+
+  if (m_contextTable.find (contextId) == m_contextTable.end ())
+    {
+      NS_LOG_LOGIC ("Context not found (" << +contextId << "), ignoring");
+      return false;
+    }
+
+  contextPrefix = m_contextTable[contextId].contextPrefix;
+  compressionAllowed = m_contextTable[contextId].compressionAllowed;
+  validLifetime = m_contextTable[contextId].validLifetime;
+
+  return true;
+}
+
+void SixLowPanNetDevice::RenewContext (uint8_t contextId, Time validLifetime)
+{
+  NS_LOG_FUNCTION (this << +contextId << validLifetime.As (Time::S));
+
+  if (contextId > 15)
+    {
+      NS_LOG_LOGIC ("Invalid context ID (" << +contextId << "), ignoring");
+      return;
+    }
+
+  if (m_contextTable.find (contextId) == m_contextTable.end ())
+    {
+      NS_LOG_LOGIC ("Context not found (" << +contextId << "), ignoring");
+      return;
+    }
+  m_contextTable[contextId].compressionAllowed = true;
+  m_contextTable[contextId].validLifetime = Simulator::Now () + validLifetime;
+  return;
+}
+
+
+void SixLowPanNetDevice::InvalidateContext (uint8_t contextId)
+{
+  NS_LOG_FUNCTION (this << +contextId);
+
+  if (contextId > 15)
+    {
+      NS_LOG_LOGIC ("Invalid context ID (" << +contextId << "), ignoring");
+      return;
+    }
+
+  if (m_contextTable.find (contextId) == m_contextTable.end ())
+    {
+      NS_LOG_LOGIC ("Context not found (" << +contextId << "), ignoring");
+      return;
+    }
+  m_contextTable[contextId].compressionAllowed = false;
+  return;
+}
+
+void SixLowPanNetDevice::RemoveContext (uint8_t contextId)
+{
+  NS_LOG_FUNCTION (this << +contextId);
+
+  if (contextId > 15)
+    {
+      NS_LOG_LOGIC ("Invalid context ID (" << +contextId << "), ignoring");
+      return;
+    }
+
+  if (m_contextTable.find (contextId) == m_contextTable.end ())
+    {
+      NS_LOG_LOGIC ("Context not found (" << +contextId << "), ignoring");
+      return;
+    }
+
+  m_contextTable.erase (contextId);
+  return;
+}
+
+bool SixLowPanNetDevice::FindUnicastCompressionContext (Ipv6Address address, uint8_t& contextId)
+{
+  NS_LOG_FUNCTION (this << address);
+
+  for (const auto& iter: m_contextTable)
+    {
+      ContextEntry context = iter.second;
+
+      if ( (context.compressionAllowed == true) && (context.validLifetime > Simulator::Now ()) )
+        {
+
+          if (address.HasPrefix (context.contextPrefix))
+            {
+              NS_LOG_LOGIC ("Fount context " << +contextId << " " <<
+                            Ipv6Address::GetOnes ().CombinePrefix (context.contextPrefix) << context.contextPrefix << " matching");
+
+              contextId = iter.first;
+              return true;
+            }
+        }
+    }
+  return false;
+}
+
+bool SixLowPanNetDevice::FindMulticastCompressionContext (Ipv6Address address, uint8_t& contextId)
+{
+  NS_LOG_FUNCTION (this << address);
+
+  // The only allowed context-based compressed multicast address is in the form
+  // ffXX:XXLL:PPPP:PPPP:PPPP:PPPP:XXXX:XXXX
+
+  for (const auto& iter: m_contextTable)
+    {
+      ContextEntry context = iter.second;
+
+      if ( (context.compressionAllowed == true) && (context.validLifetime > Simulator::Now ()) )
+        {
+          uint8_t contextLength = context.contextPrefix.GetPrefixLength ();
+
+          if (contextLength <= 64) // only 64-bit prefixes or less are allowed.
+            {
+              uint8_t contextBytes[16];
+              uint8_t addressBytes[16];
+
+              context.contextPrefix.GetBytes (contextBytes);
+              address.GetBytes (addressBytes);
+
+              if (addressBytes[3] == contextLength &&
+                  addressBytes[4] == contextBytes[0] &&
+                  addressBytes[5] == contextBytes[1] &&
+                  addressBytes[6] == contextBytes[2] &&
+                  addressBytes[7] == contextBytes[3] &&
+                  addressBytes[8] == contextBytes[4] &&
+                  addressBytes[9] == contextBytes[5] &&
+                  addressBytes[10] == contextBytes[6] &&
+                  addressBytes[11] == contextBytes[7])
+                {
+                  NS_LOG_LOGIC ("Fount context " << +contextId << " " <<
+                                Ipv6Address::GetOnes ().CombinePrefix (context.contextPrefix) << context.contextPrefix << " matching");
+
+                  contextId = iter.first;
+                  return true;
+                }
+            }
+        }
+    }
+  return false;
+}
+
+Ipv6Address SixLowPanNetDevice::CleanPrefix (Ipv6Address address, Ipv6Prefix prefix)
+{
+  uint8_t addressBytes[16];
+  address.GetBytes (addressBytes);
+  uint8_t prefixLength = prefix.GetPrefixLength ();
+
+  uint8_t bytesToClean = prefixLength / 8;
+  uint8_t bitsToClean = prefixLength % 8;
+  for (uint8_t i=0; i<bytesToClean; i++)
+    {
+      addressBytes[i] = 0;
+    }
+  if (bitsToClean)
+    {
+      uint8_t cleanupMask = (1<<bitsToClean)-1;
+      addressBytes[bytesToClean] &= cleanupMask;
+    }
+
+  Ipv6Address cleanedAddress = Ipv6Address::Deserialize (addressBytes);
+
+  return cleanedAddress;
+}
+
 }
 
 // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/sixlowpan/model/sixlowpan-net-device.h ns-3.34/src/sixlowpan/model/sixlowpan-net-device.h
--- ns-3.33/src/sixlowpan/model/sixlowpan-net-device.h	2021-01-09 10:19:22.000000000 -0800
+++ ns-3.34/src/sixlowpan/model/sixlowpan-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -70,10 +70,11 @@
    */
   enum DropReason
   {
-    DROP_FRAGMENT_TIMEOUT = 1,   /**< Fragment timeout exceeded */
-    DROP_FRAGMENT_BUFFER_FULL,   /**< Fragment buffer size exceeded */
-    DROP_UNKNOWN_EXTENSION,      /**< Unsupported compression kind */
-    DROP_DISALLOWED_COMPRESSION  /**< HC1 while in IPHC mode or viceversa */
+    DROP_FRAGMENT_TIMEOUT = 1,    /**< Fragment timeout exceeded */
+    DROP_FRAGMENT_BUFFER_FULL,    /**< Fragment buffer size exceeded */
+    DROP_UNKNOWN_EXTENSION,       /**< Unsupported compression kind */
+    DROP_DISALLOWED_COMPRESSION,  /**< HC1 while in IPHC mode or viceversa */
+    DROP_SATETFUL_DECOMPRESSION_PROBLEM, /**< Decompression failed due to missing or expired context */
   };
 
   /**
@@ -162,7 +163,7 @@
                                       uint32_t ifindex);
 
   /**
-   * TracedCallback signature for
+   * TracedCallback signature fo packet drop events
    *
    * \param [in] reason The reason for the drop.
    * \param [in] packet The packet.
@@ -177,6 +178,58 @@
                                       Ptr<SixLowPanNetDevice> sixNetDevice,
                                       uint32_t ifindex);
 
+  /**
+   * Add, remove, or update a context used in IPHC stateful compression.
+   *
+   * A context with a zero validLifetime will be immediately removed.
+   *
+   * \param [in] contextId context id (most be between 0 and 15 included).
+   * \param [in] contextPrefix context prefix to be used in compression/decompression.
+   * \param [in] compressionAllowed compression and decompression allowed (true), decompression only (false).
+   * \param [in] validLifetime validity time (relative to the actual time).
+   *
+   */
+  void AddContext (uint8_t contextId, Ipv6Prefix contextPrefix, bool compressionAllowed, Time validLifetime);
+
+  /**
+   * Get a context used in IPHC stateful compression.
+   *
+   * \param [in] contextId context id (most be between 0 and 15 included).
+   * \param [out] contextPrefix context prefix to be used in compression/decompression.
+   * \param [out] compressionAllowed compression and decompression allowed (true), decompression only (false).
+   * \param [out] validLifetime validity time (relative to the actual time).
+   *
+   * \return false if the context has not been found.
+   *
+   */
+  bool GetContext (uint8_t contextId, Ipv6Prefix& contextPrefix, bool& compressionAllowed, Time& validLifetime);
+
+  /**
+   * Renew a context used in IPHC stateful compression.
+   *
+   * The context will have its lifetime extended and its validity for compression re-enabled.
+   *
+   * \param [in] contextId context id (most be between 0 and 15 included).
+   * \param [in] validLifetime validity time (relative to the actual time).
+   */
+  void RenewContext (uint8_t contextId, Time validLifetime);
+
+  /**
+   * Invalidate a context used in IPHC stateful compression.
+   *
+   * An invalid context will not be used for compression but it will be used for decompression.
+   *
+   * \param [in] contextId context id (most be between 0 and 15 included).
+   */
+  void InvalidateContext (uint8_t contextId);
+
+  /**
+   * Remove a context used in IPHC stateful compression.
+   *
+   * \param [in] contextId context id (most be between 0 and 15 included).
+   */
+  void RemoveContext (uint8_t contextId);
+
 protected:
   virtual void DoDispose (void);
 
@@ -202,7 +255,6 @@
    * \param [in] source The source address.
    * \param [in] destination The destination address.
    * \param [in] packetType The packet kind (e.g., HOST, BROADCAST, etc.).
-   * \return The IPv6 link-local address.
    */
   void ReceiveFromDevice (Ptr<NetDevice> device, Ptr<const Packet> packet, uint16_t protocol,
                           Address const &source, Address const &destination, PacketType packetType);
@@ -312,8 +364,9 @@
    * \param [in] packet The packet to be compressed.
    * \param [in] src The MAC source address.
    * \param [in] dst The MAC destination address.
+   * \return true if the packet can not be decompressed due to wrong context informations.
    */
-  void DecompressLowPanIphc (Ptr<Packet> packet, Address const &src, Address const &dst);
+  bool DecompressLowPanIphc (Ptr<Packet> packet, Address const &src, Address const &dst);
 
   /**
    * \brief Compress the headers according to NHC compression.
@@ -332,9 +385,9 @@
    * \param [in] dst The MAC destination address.
    * \param [in] srcAddress The IPv6 source address.
    * \param [in] dstAddress The IPv6 destination address.
-   * \return The decompressed header type.
+   * \return A std::pair containing the decompressed header type and a flag - true if the packet can not be decompressed due to wrong context informations.
    */
-  uint8_t DecompressLowPanNhc (Ptr<Packet> packet, Address const &src, Address const &dst, Ipv6Address srcAddress, Ipv6Address dstAddress);
+  std::pair<uint8_t, bool> DecompressLowPanNhc (Ptr<Packet> packet, Address const &src, Address const &dst, Ipv6Address srcAddress, Ipv6Address dstAddress);
 
   /**
    * \brief Compress the headers according to NHC compression.
@@ -472,9 +525,10 @@
    * \param [in] packet the packet to be fragmented (with headers already compressed with 6LoWPAN).
    * \param [in] origPacketSize the size of the IP packet before the 6LoWPAN header compression, including the IP/L4 headers.
    * \param [in] origHdrSize the size of the IP header before the 6LoWPAN header compression.
+   * \param [in] extraHdrSize the sum of the sizes of BC0 header and MESH header if mesh routing is used or 0.
    * \param [out] listFragments A reference to the list of the resulting packets, all with the proper headers in place.
    */
-  void DoFragmentation (Ptr<Packet> packet, uint32_t origPacketSize, uint32_t origHdrSize,
+  void DoFragmentation (Ptr<Packet> packet, uint32_t origPacketSize, uint32_t origHdrSize, uint32_t extraHdrSize,
                         std::list<Ptr<Packet> >& listFragments);
 
   /**
@@ -549,6 +603,48 @@
   uint32_t m_compressionThreshold; //!< Minimum L2 payload size.
 
   Ptr<UniformRandomVariable> m_rng; //!< Rng for the fragments tag.
+
+  /**
+   * Structure holding the informations for a context (used in compression and decompression)
+   */
+  struct ContextEntry
+  {
+    Ipv6Prefix contextPrefix;    //!< context prefix to be used in compression/decompression
+    bool compressionAllowed;     //!< compression and decompression allowed (true), decompression only (false)
+    Time validLifetime;          //!< validity period
+  };
+
+  std::map<uint8_t, ContextEntry> m_contextTable; //!< Table of the contexts used in compression/decompression
+
+  /**
+   * \brief Finds if the given unicast address matches a context for compression
+   *
+   * \param[in] address the address to check
+   * \param[out] contextId the context found
+   * \return true if a valid context has been found
+   */
+  bool FindUnicastCompressionContext (Ipv6Address address, uint8_t& contextId);
+
+  /**
+   * \brief Finds if the given multicast address matches a context for compression
+   *
+   * \param[in] address the address to check
+   * \param[out] contextId the context found
+   * \return true if a valid context has been found
+   */
+  bool FindMulticastCompressionContext (Ipv6Address address, uint8_t& contextId);
+
+  /**
+   * \brief Clean an address from its prefix.
+   *
+   * This function is used to find the relevant bits to be sent in stateful IPHC compression.
+   * Only the pefix length is used - the address prefix is assumed to be matching the prefix.
+   *
+   * \param address the address to be cleaned
+   * \param prefix the prefix to remove
+   * \return An address with the prefix zeroed.
+   */
+  Ipv6Address CleanPrefix (Ipv6Address address, Ipv6Prefix prefix);
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/sixlowpan/test/mock-net-device.cc ns-3.34/src/sixlowpan/test/mock-net-device.cc
--- ns-3.33/src/sixlowpan/test/mock-net-device.cc	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/sixlowpan/test/mock-net-device.cc	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,348 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+#include "mock-net-device.h"
+#include "ns3/node.h"
+#include "ns3/packet.h"
+#include "ns3/log.h"
+#include "ns3/pointer.h"
+#include "ns3/trace-source-accessor.h"
+#include "ns3/boolean.h"
+#include "ns3/simulator.h"
+#include "ns3/channel.h"
+#include "ns3/mac64-address.h"
+#include "ns3/mac48-address.h"
+#include "ns3/mac16-address.h"
+#include "ns3/mac8-address.h"
+
+namespace ns3 {
+
+NS_LOG_COMPONENT_DEFINE ("MockNetDevice");
+NS_OBJECT_ENSURE_REGISTERED (MockNetDevice);
+
+TypeId
+MockNetDevice::GetTypeId (void)
+{
+  static TypeId tid = TypeId ("ns3::MockNetDevice")
+    .SetParent<NetDevice> ()
+    .SetGroupName("Network")
+    .AddConstructor<MockNetDevice> ()
+    .AddAttribute ("PointToPointMode",
+                   "The device is configured in Point to Point mode",
+                   BooleanValue (false),
+                   MakeBooleanAccessor (&MockNetDevice::m_pointToPointMode),
+                   MakeBooleanChecker ())
+  ;
+  return tid;
+}
+
+MockNetDevice::MockNetDevice ()
+  : m_node (0),
+    m_mtu (0xffff),
+    m_ifIndex (0),
+    m_linkUp (true)
+{
+  NS_LOG_FUNCTION (this);
+}
+
+void
+MockNetDevice::Receive (Ptr<Packet> packet, uint16_t protocol,
+                          Address to, Address from, NetDevice::PacketType packetType)
+{
+  NS_LOG_FUNCTION (this << packet << protocol << to << from);
+
+  if (packetType != NetDevice::PACKET_OTHERHOST)
+    {
+      m_rxCallback (this, packet, protocol, from);
+    }
+
+  if (!m_promiscCallback.IsNull ())
+    {
+      m_promiscCallback (this, packet, protocol, from, to, packetType);
+    }
+}
+
+void
+MockNetDevice::SetIfIndex (const uint32_t index)
+{
+  NS_LOG_FUNCTION (this << index);
+  m_ifIndex = index;
+}
+
+uint32_t
+MockNetDevice::GetIfIndex (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_ifIndex;
+}
+
+Ptr<Channel>
+MockNetDevice::GetChannel (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return 0;
+}
+
+void
+MockNetDevice::SetAddress (Address address)
+{
+  NS_LOG_FUNCTION (this << address);
+  m_address = address;
+}
+
+Address
+MockNetDevice::GetAddress (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_address;
+}
+
+bool
+MockNetDevice::SetMtu (const uint16_t mtu)
+{
+  NS_LOG_FUNCTION (this << mtu);
+  m_mtu = mtu;
+  return true;
+}
+
+uint16_t
+MockNetDevice::GetMtu (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_mtu;
+}
+
+bool
+MockNetDevice::IsLinkUp (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_linkUp;
+}
+
+void
+MockNetDevice::AddLinkChangeCallback (Callback<void> callback)
+{
+  NS_LOG_FUNCTION (this << &callback);
+  m_linkChangeCallbacks.ConnectWithoutContext (callback);
+}
+
+bool
+MockNetDevice::IsBroadcast (void) const
+{
+  NS_LOG_FUNCTION (this);
+  if (m_pointToPointMode)
+    {
+      return false;
+    }
+  if (Mac64Address::IsMatchingType (m_address))
+    {
+      return false;
+    }
+  if (Mac8Address::IsMatchingType (m_address))
+    {
+      return false;
+    }
+
+  return true;
+}
+
+Address
+MockNetDevice::GetBroadcast (void) const
+{
+  NS_LOG_FUNCTION (this);
+
+  Address address;
+
+  if (Mac48Address::IsMatchingType (m_address))
+    {
+      address = Mac48Address::GetBroadcast ();
+    }
+  else if (Mac16Address::IsMatchingType (m_address))
+    {
+      address = Mac16Address::GetBroadcast ();
+    }
+
+  return address;
+}
+
+bool
+MockNetDevice::IsMulticast (void) const
+{
+  NS_LOG_FUNCTION (this);
+  if (m_pointToPointMode)
+    {
+      return false;
+    }
+  if (Mac64Address::IsMatchingType (m_address))
+    {
+      return false;
+    }
+  if (Mac8Address::IsMatchingType (m_address))
+    {
+      return false;
+    }
+
+  return true;
+}
+
+Address
+MockNetDevice::GetMulticast (Ipv4Address multicastGroup) const
+{
+  NS_LOG_FUNCTION (this << multicastGroup);
+
+  Address address;
+
+  if (Mac48Address::IsMatchingType (m_address))
+    {
+      address = Mac48Address::GetMulticast (multicastGroup);
+    }
+  else if (Mac16Address::IsMatchingType (m_address))
+    {
+      address = Mac16Address::GetMulticast (Ipv6Address::MakeIpv4MappedAddress (multicastGroup));
+    }
+
+  return address;
+}
+
+Address MockNetDevice::GetMulticast (Ipv6Address addr) const
+{
+  NS_LOG_FUNCTION (this << addr);
+  Address address;
+
+  if (Mac48Address::IsMatchingType (m_address))
+    {
+      address = Mac48Address::GetMulticast (addr);
+    }
+  else if (Mac16Address::IsMatchingType (m_address))
+    {
+      address = Mac16Address::GetMulticast (addr);
+    }
+
+  return address;
+}
+
+bool
+MockNetDevice::IsPointToPoint (void) const
+{
+  NS_LOG_FUNCTION (this);
+  if (m_pointToPointMode)
+    {
+      return true;
+    }
+  return false;
+}
+
+bool
+MockNetDevice::IsBridge (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return false;
+}
+
+bool
+MockNetDevice::Send (Ptr<Packet> packet, const Address& dest, uint16_t protocolNumber)
+{
+  NS_LOG_FUNCTION (this << packet << dest << protocolNumber);
+
+  return SendFrom (packet, m_address, dest, protocolNumber);
+}
+
+bool
+MockNetDevice::SendFrom (Ptr<Packet> p, const Address& source, const Address& dest, uint16_t protocolNumber)
+{
+  NS_LOG_FUNCTION (this << p << source << dest << protocolNumber);
+  if (p->GetSize () > GetMtu ())
+    {
+      return false;
+    }
+
+  if (!m_sendCallback.IsNull ())
+    {
+      m_sendCallback (this, p, protocolNumber, source, dest, NetDevice::PACKET_HOST);
+    }
+
+  return true;
+}
+
+
+Ptr<Node>
+MockNetDevice::GetNode (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return m_node;
+}
+void
+MockNetDevice::SetNode (Ptr<Node> node)
+{
+  NS_LOG_FUNCTION (this << node);
+  m_node = node;
+}
+
+bool
+MockNetDevice::NeedsArp (void) const
+{
+  NS_LOG_FUNCTION (this);
+  if (m_pointToPointMode)
+    {
+      return false;
+    }
+  return true;
+}
+
+void
+MockNetDevice::SetReceiveCallback (NetDevice::ReceiveCallback cb)
+{
+  NS_LOG_FUNCTION (this << &cb);
+  m_rxCallback = cb;
+}
+
+void
+MockNetDevice::DoDispose (void)
+{
+  NS_LOG_FUNCTION (this);
+  m_node = 0;
+  m_rxCallback.Nullify ();
+  m_promiscCallback.Nullify ();
+  m_sendCallback.Nullify ();
+  NetDevice::DoDispose ();
+}
+
+void
+MockNetDevice::SetPromiscReceiveCallback (PromiscReceiveCallback cb)
+{
+  NS_LOG_FUNCTION (this << &cb);
+  m_promiscCallback = cb;
+}
+
+bool
+MockNetDevice::SupportsSendFrom (void) const
+{
+  NS_LOG_FUNCTION (this);
+  return true;
+}
+
+void
+MockNetDevice::SetSendCallback (PromiscReceiveCallback cb)
+{
+  NS_LOG_FUNCTION (this << &cb);
+  m_sendCallback = cb;
+}
+
+
+} // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.33/src/sixlowpan/test/mock-net-device.h ns-3.34/src/sixlowpan/test/mock-net-device.h
--- ns-3.33/src/sixlowpan/test/mock-net-device.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.34/src/sixlowpan/test/mock-net-device.h	2021-07-14 10:31:07.000000000 -0700
@@ -0,0 +1,132 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ * Copyright (c) 2020 Universita' di Firenze, Italy
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Tommaso Pecorella <tommaso.pecorella@unifi.it>
+ */
+#ifndef MOCK_NET_DEVICE_H
+#define MOCK_NET_DEVICE_H
+
+#include <stdint.h>
+#include <string>
+
+#include "ns3/traced-callback.h"
+#include "ns3/net-device.h"
+
+namespace ns3 {
+
+class Node;
+
+/**
+ * \ingroup netdevice
+ *
+ * This device assumes 48-bit mac addressing; there is also the possibility to
+ * add an ErrorModel if you want to force losses on the device.
+ * 
+ * The device can be installed on a node through the MockNetDeviceHelper.
+ * In case of manual creation, the user is responsible for assigning an unique
+ * address to the device.
+ *
+ * By default the device is in Broadcast mode, with infinite bandwidth.
+ *
+ * \brief simple net device for simple things and testing
+ */
+class MockNetDevice : public NetDevice
+{
+public:
+  /**
+   * \brief Get the type ID.
+   * \return the object TypeId
+   */
+  static TypeId GetTypeId (void);
+  MockNetDevice ();
+
+  /**
+   * Pretend that a packet has been received from a connected Channel.
+   *
+   * Note that no analysis is performed on the addresses, and the
+   * packet is forwarded to the callbacks according to the packetType.
+   *
+   * \param packet Packet received on the channel
+   * \param protocol protocol number
+   * \param to address packet should be sent to
+   * \param from address packet was sent from
+   * \param packetType type of the packet (e.g., NetDevice::PACKET_HOST, NetDevice::PACKET_OTHERHOST, etc.)
+   */
+  void Receive (Ptr<Packet> packet, uint16_t protocol, Address to, Address from, NetDevice::PacketType packetType);
+
+  // inherited from NetDevice base class.
+  virtual void SetIfIndex (const uint32_t index);
+  virtual uint32_t GetIfIndex (void) const;
+  virtual Ptr<Channel> GetChannel (void) const;
+  virtual void SetAddress (Address address);
+  virtual Address GetAddress (void) const;
+  virtual bool SetMtu (const uint16_t mtu);
+  virtual uint16_t GetMtu (void) const;
+  virtual bool IsLinkUp (void) const;
+  virtual void AddLinkChangeCallback (Callback<void> callback);
+  virtual bool IsBroadcast (void) const;
+  virtual Address GetBroadcast (void) const;
+  virtual bool IsMulticast (void) const;
+  virtual Address GetMulticast (Ipv4Address multicastGroup) const;
+  virtual Address GetMulticast (Ipv6Address addr) const;
+  virtual bool IsPointToPoint (void) const;
+  virtual bool IsBridge (void) const;
+  virtual bool Send (Ptr<Packet> packet, const Address& dest, uint16_t protocolNumber);
+  virtual bool SendFrom (Ptr<Packet> packet, const Address& source, const Address& dest, uint16_t protocolNumber);
+  virtual Ptr<Node> GetNode (void) const;
+  virtual void SetNode (Ptr<Node> node);
+  virtual bool NeedsArp (void) const;
+  virtual void SetReceiveCallback (NetDevice::ReceiveCallback cb);
+  virtual void SetPromiscReceiveCallback (PromiscReceiveCallback cb);
+  virtual bool SupportsSendFrom (void) const;
+
+  /**
+   *
+   * Add a callback to be invoked when the MockNetDevice has a packet to "send".
+   *
+   * In the callback the PacketType is always set to NetDevice::PACKET_HOST.
+   *
+   * \param cb callback to invoke whenever the MockNetDevice has one packet to "send".
+   *
+   */
+  void SetSendCallback (PromiscReceiveCallback cb);
+
+protected:
+  virtual void DoDispose (void);
+
+private:
+
+  NetDevice::ReceiveCallback m_rxCallback; //!< Receive callback
+  NetDevice::PromiscReceiveCallback m_promiscCallback; //!< Promiscuous receive callback
+  NetDevice::PromiscReceiveCallback m_sendCallback; //!< Send callback
+  Ptr<Node> m_node; //!< Node this netDevice is associated to
+  uint16_t m_mtu;   //!< MTU
+  uint32_t m_ifIndex; //!< Interface index
+  Address m_address; //!< MAC address
+
+  bool m_linkUp; //!< Flag indicating whether or not the link is up
+  bool m_pointToPointMode; //!< Enabling this will disable Broadcast and Arp.
+
+  /**
+   * List of callbacks to fire if the link changes state (up or down).
+   */
+  TracedCallback<> m_linkChangeCallbacks;
+};
+
+} // namespace ns3
+
+#endif /* MOCK_NET_DEVICE_H */
